<?php
declare(strict_types=1);

namespace Inti\Media\Plugin;

use Inti\Container\Exception\MissingDependencyException;
use League\Flysystem\FilesystemOperator;
use Psr\Container\ContainerInterface;

/**
 * Class GathImageFactory
 *
 * @package Inti\Media\Plugin
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-media
 */
final class GathImageFactory
{
    public function __invoke(ContainerInterface $container): GathImage
    {
        if (!$container->has(FilesystemOperator::class)) {
            throw MissingDependencyException::dependencyForService(
                FilesystemOperator::class,
                GathImage::class
            );
        }

        return new GathImage(
            $container->get('ImageMetadataCache'),
            $container->get(FilesystemOperator::class)
        );
    }
}
